/************************callback sync queue**************************************/

window._syncCallback_lockedtime = 0; //zero is unlocked
window._syncCallbackQueue = [];
var _SYNCRATE = 10; //ms sync rate
var _SYNCTIME_FAILED = 3000; // 3s fail time if queue is locked too long.

function SyncCallback(callback, refreshCallback) {
  window._syncCallbackQueue.push({ 'callback': callback, 'func': refreshCallback });
}

//Called from c# to unlock the queue
function SyncCallbackDequeue(args) {
    if (typeof window._syncCallbackQueue[0].func != "undefined")
       window._syncCallbackQueue[0].func(args); //do callback function if there is any
    window._syncCallbackQueue.shift(); //remove first
    window._syncCallback_lockedtime = 0;
}

setInterval(function () {

  if (window._syncCallback_lockedtime >= _SYNCTIME_FAILED)
  {
    debug("Callback queue failed on " + window._syncCallbackQueue[0].callback + " and was reset");
    window._syncCallbackQueue = []; //reset the queue
    window._syncCallback_lockedtime = 0; //unlock
  }

  if ((window._syncCallback_lockedtime == 0) && window._syncCallbackQueue.length > 0) {
    window.location = window._syncCallbackQueue[0].callback;
  }
  if (window._syncCallbackQueue.length > 0)
    window._syncCallback_lockedtime += _SYNCRATE;

}, _SYNCRATE);